
// am2dsp.hxx
#ifndef _am2dsp_hxx
#define _am2dsp_hxx

#pragma warning( disable:4244 ) // conv. 'intptr_t' to 'long', possible loss of data rubbish
#pragma warning( disable:4267 ) // conv. 'size_t' to 'unsigned int', possible loss rubbish

#include <sstream>
#include <iostream>
#include <string>
#include <vector>
#include <PLIB/ul.h>
#include <io.h>
#include <sys/stat.h>
#include <algorithm> // sort()
//#include <cctype>
//#include <iomanip>
//#include <iterator>
//#include <utility>

using namespace std;

typedef vector<string> string_list;

// global, from 'main'
extern string base_path; // base, where te first AM file found
extern string proj_name; // this the the NAME of the 'solution', and 'project' ...

// makefile.am load list stuff
// structure, to hold the AM files loaded, and lines/information they contain
typedef struct { /* tagAMLIB */
   size_t lib_order;
   string lib_folder; // full folder path (of makefile.am)
   string lib_amin; // full/(relative) path of file
   string lib_src; // 'name' for source line
   string lib_short; // short lib name
   string lib_short2; // even 'shorter' name 'snippet'
   string lib_ulib; // 'unix' library name like 'libAbc.a'
   string_list lib_lines; // list of 'lines' in the file
   string_list lib_includedir;
   string_list lib_subs; // list of SUBDIRS, for this make
   string_list lib_list; // list of SOURCES, for library
   string_list lib_headers; // list of HEADERS, for library
   string_list lib_pgm_list;
   int lib_done;
}AMLIB, * PAMLIB;

typedef vector<AMLIB> vAMLIBS; // set of AM files

extern vAMLIBS  vam; // full final list of AM items

#include "fixed.hxx" // get DSP header stuff in oe hit ..
#include "sprtf.hxx"
#include "fg_dsp.hxx"
#include "amwrite.hxx"

// #define  sprtf
#define G_LOG(a) { \
   ostringstream temp;\
   temp << a;\
   cout << temp.str() << endl;\
   sprtf( "%s\n", temp.str().c_str() ); }

// other local includes
#include "amload.hxx" // load a file, as lines

// some more macros

#define WRT(a,b) oi(a); wtn = fwrite( a, 1, b, fp );\
   if( wtn != b ) { goto Do_CLOSE; } else { *a = 0; tot += wtn; }

#define OUT1(a) strcpy(pbuf,a); ilen = strlen(pbuf); WRT(pbuf,ilen)


#endif // #ifndef _am2dsp_hxx

// eof - am2dsp.hxx
